package packages.middleware.pub.server.browse;
import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.eka.middleware.service.DataPipeline;
import com.eka.middleware.service.PropertyManager;
import com.eka.middleware.template.SnippetException;
public final class getPackagesAsTree{
	public static final void main(DataPipeline dataPipeline) throws SnippetException{
try {
  	dataPipeline.appLog("OPERATION", "getPackagesAsTree");
    String packageDir = PropertyManager.getPackagePath(dataPipeline.rp.getTenant()) +"packages/";
  	dataPipeline.appLog("EXTRACTED_PACKAGE_DIRECTORY",packageDir);
    File file = new File(packageDir);
    List<Map<String, Object>> children = new ArrayList<Map<String, Object>>();
    File fileList[] = file.listFiles();
    for (File fyle : fileList) {
        Map<String, Object> childMap = getTreeMap(fyle, "package");
        if (childMap != null) {
            children.add(childMap);
          	dataPipeline.appLog("CHILD_ADDED", "Added child to the list");
        }
    }

  	dataPipeline.appLog("CHILDREN_PROCESSED", "Total children in the list : " + children.size());
    dataPipeline.clear();
    dataPipeline.put("text", "packages");
    dataPipeline.put("type", "root");
    dataPipeline.put("children", children);
  	dataPipeline.appLog("SUCCESSFUL", "Get Packages as a tree successfully");
} catch (Exception e) {
    dataPipeline.clear();
    dataPipeline.put("response", e.getStackTrace());
  	dataPipeline.appLog("SERVICE_ERROR", "An error occurred: " + e.getMessage());
}
	}
private static Map<String, Object> getTreeMap(File file, String type) {
    Map<String, Object> map = new HashMap<String, Object>();
    String allowedTypes = "service,map,doc,api,flow,package,root,folder,properties,jar,jdbc,sql,pem,graphql,txt,csv";
    int indx = file.getName().lastIndexOf(".") + 1;
    String fileType = file.getName().substring(indx);

    // Skip if the file name is "build"
    if (file.getName().equals("build") && !file.isDirectory()) {
        return null;
    }

    map.put("text", file.getName().replace("." + fileType, ""));
    if (file.isDirectory()) {
        map.put("type", type);
        List<Map<String, Object>> children = new ArrayList<Map<String, Object>>();
        File fileList[] = file.listFiles();
        for (File fyle : fileList) {
            int indx2 = fyle.getName().lastIndexOf(".") + 1;
            String fileType2 = fyle.getName().substring(indx2);
            if (allowedTypes.contains(fileType2) || fyle.isDirectory()) {
                Map<String, Object> childMap = getTreeMap(fyle, "folder");
                if (childMap != null) {
                    children.add(childMap);
                }
            }
        }
        map.put("children", children);
    } else {
        if (indx != 0 && allowedTypes.contains(fileType)) {
            map.put("type", fileType);
        }
    }
    return map;
}

}