package packages.middleware.pub.server.browse;
import java.io.File;
import java.util.regex.Pattern;
import java.sql.Connection;
import graphql.schema.database.generator.*;
import graphql.schema.*;

import com.eka.middleware.adapter.SQL;
import com.eka.middleware.service.DataPipeline;
import com.eka.middleware.service.ServiceUtils;
import com.eka.middleware.template.SnippetException;
import com.eka.middleware.service.PropertyManager;
import graphql.schema.GraphQLSchema;
public final class saveFile{
	public static final void main(DataPipeline dataPipeline) throws SnippetException{
try {
            System.out.println("**********************"+dataPipeline.getUrlPath());
  			dataPipeline.appLog("SAVING_FILE_START", "SAVING A FILE - URL Path: " + dataPipeline.getUrlPath());
  			dataPipeline.appLog("OPERATION", "saveFile");
            String location = dataPipeline.getString("fileLocation");
            if (null == location) {
                location = dataPipeline.getUrlPath().split("POST/files/")[1];
            }
            System.out.println("++++++++++++++++++++++++++++++++++++"+location);
  			dataPipeline.appLog("FILE_LOCATION", location);
            String split[] = location.split(Pattern.quote("."));
            String ext = split[split.length - 1];
            location = PropertyManager.getPackagePath(dataPipeline.rp.getTenant())
                    + location;
            dataPipeline.clear();
            dataPipeline.put("Location", location);
            File file = new File(location);
            //System.out.println("Saving "+location);
            if(!file.exists()) {
              	dataPipeline.appLog("NEW_FILE_CREATION",location);
                file.getParentFile().mkdirs();
                file.createNewFile();
            }
            if(location.endsWith(".properties")){
              	dataPipeline.appLog("SAVING_PROPERTIES_FILE", "File ends with '.properties' ");

                byte[] body = (byte[])dataPipeline.get("body");
                if (null != body) {
                    dataPipeline.saveProperties(location,body);
                } else {
                    dataPipeline.saveProperties(location,dataPipeline.getBody());
                }
            } else if(location.endsWith(".jdbc")){
  				dataPipeline.appLog("SAVING_JDBC_FILE", "File ends with '.jdbc' ");
                dataPipeline.saveJdbc(dataPipeline,file.toPath());
                String JDBC = dataPipeline.getUrlPath().replaceAll("POST/files/", "");
                String pPath=PropertyManager.getPackagePath(dataPipeline.rp.getTenant());
                String connectionPropFile=pPath + JDBC;
                Connection myCon = SQL.getConnection(JDBC.replace("packages", "").replace(".jdbc", ""), dataPipeline);

                new Thread(new Runnable() {
                    @Override
                    public void run() {
                      	dataPipeline.appLog("CREATING_SCHEMA", "Asynchronously creating schema for JDBC file: " + JDBC);
                        DBSchemaGenerator.createSchema(myCon, connectionPropFile);
                        //String schemaString = GraphQLSchemaUtil.convertToString(schema);
                        //File connectionFile = new File(connectionPropFile);
                        ///String graphQLLocation = connectionFile.getParent() + "/" + (connectionFile.getName().replaceAll(".jdbc", ".graphql"));
                        //FileUtil.writeToFile(graphQLLocation, schemaString);
                    }
                }).start();

            }else{
                java.nio.file.Files.write(file.toPath(), dataPipeline.getBody());
			}
            //System.out.println("++++++++++++++++++++++++++++++++++++"+location);
  			dataPipeline.appLog("FILE_SAVED_AT_LOCATION",location);
            dataPipeline.clear();
            dataPipeline.put("status", "Saved");

        } catch (Throwable e) {
            e.printStackTrace();
            dataPipeline.clear();
            dataPipeline.put("error", e.getMessage());
          	dataPipeline.appLog("FILE_SAVING_ERROR",e.getMessage());
            dataPipeline.setResponseStatus(500);
            dataPipeline.put("status", "Not Modified");
            new SnippetException(dataPipeline,"Failed while saving file", new Exception(e));
        }
	}


}