package packages.middleware.pub.server.build.api;
import com.eka.middleware.service.DataPipeline;
import com.eka.middleware.service.ServiceUtils;
import com.eka.middleware.template.SnippetException;
import java.io.InputStream;
import java.io.FileOutputStream;
import org.apache.commons.io.IOUtils;

import com.eka.middleware.service.ServiceUtils;
import java.util.*;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;
import java.util.zip.ZipEntry;
import org.apache.commons.io.FileUtils;
import com.eka.middleware.template.MultiPart;
import com.eka.middleware.service.PropertyManager;
public final class importBuild{
	public static final void main(DataPipeline dataPipeline) throws SnippetException{
try{
            dataPipeline.appLog("OPERATION","importBuild");
            //String folder=dataPipeline.getString("dest");
            String packagePath=PropertyManager.getPackagePath(dataPipeline.rp.getTenant());
            dataPipeline.appLog("EXTRACTED_PACKAGE_PATH", packagePath);
            String buildsDirPath=packagePath+"builds/import/";
            dataPipeline.appLog("EXTRACTED_BUILDS_DIRECTORY_PATH", buildsDirPath);
            InputStream is=dataPipeline.getFile("file");
            String fileName=dataPipeline.getFileName("file");
            dataPipeline.appLog("IMPORT_FILE_NAME", fileName);
            String location = buildsDirPath+fileName;
            dataPipeline.appLog("EXTRACTED_IMPORT_LOCATION", location);
            File dir=new File(buildsDirPath);
            if(!dir.exists())
                dir.mkdirs();
            dataPipeline.appLog("DIRECTORY_CREATED", "Directory has been created");
            FileOutputStream fos=new FileOutputStream(new File(location));
            IOUtils.copy(is,fos);
            fos.flush();
            fos.close();
            dataPipeline.clear();
            dataPipeline.appLog("IMPORT_FILE_SAVED", "Saved import file to location: " + location);
            //Backup packages
            createRestorePoint(fileName,dataPipeline);
            dataPipeline.appLog("BACKUP_CREATED",fileName);
            //Unzip and deploy
            unzip(location,packagePath,dataPipeline);
            dataPipeline.appLog("UNZIP_AND_DEPLOY",fileName);
            //import URLaliases
            String UrlAliasFilepath=packagePath+(("URLAlias_"+fileName+"#").replace(".zip#",".properties"));
            Boolean importSuccessful=importURLAliases(UrlAliasFilepath, dataPipeline);
            dataPipeline.appLog("IMPORTED_URL_ALIASES", "Imported URL aliases for: " + fileName);
            dataPipeline.put("status", "Saved");
            dataPipeline.appLog("SERVICE_STATUS", "Imported and saved build");
        }catch(Exception e){
            dataPipeline.clear();
            dataPipeline.put("error", e.getMessage());
            dataPipeline.appLog("SERVICE_ERROR",e.getMessage());
            dataPipeline.setResponseStatus(500);
            dataPipeline.put("status", "Not Modified");
            new SnippetException(dataPipeline,"Failed while saving file", new Exception(e));
        }
	}

private static boolean importURLAliases(String UrlAliasFilepath, DataPipeline dp) throws Exception{
        Boolean importSuccessful=true;
        Properties prop=new Properties();
        File file=new File(UrlAliasFilepath);
        if(!file.exists()){
            dp.put("msg","Alias file not found. Path: "+UrlAliasFilepath);
            dp.appLog("ALIAS_FILE_NOT_FOUND",UrlAliasFilepath);
            return true;
        }
        FileInputStream aliasFIS=new FileInputStream(file);
        prop.load(aliasFIS);
        prop.forEach((k,v)->{
            //if(dp.getString("error")==null){
            String key=(String)k;
            String value=(String)v;
            dp.map("fqn",value);
            dp.map("alias",key);
            try{
                dp.apply("packages.middleware.pub.server.browse.registerURLAlias");
                String msg=dp.getString("msg");
                if(!"Saved".equals(msg))
                    dp.put("error",msg);

            }catch(Exception e){
                dp.put("error",e.getMessage());
                dp.appLog("REGISTER_ALIAS_ERROR", e.getMessage());
            }
            dp.drop("fqn");
            dp.drop("alias");
            // }
        });
        aliasFIS.close();
        if(dp.getString("error")!=null)
            importSuccessful=false;
        dp.appLog("IMPORT_STATUS","importBuild was not successful.");
        file.delete();
        dp.appLog("IMPORT_STATUS", "importBuild was successful");
        return importSuccessful;
    }

    private static void unzip(String zipFilePath, String destDir, DataPipeline dp) throws Exception {
        File dir = new File(destDir);
        String unZippedFolderPath = null;
        // create output directory if it doesn't exist
        if (!dir.exists()) dir.mkdirs();
        dp.appLog("NEW_DIRECTORY_CREATED", destDir);
        FileInputStream fis;
        dp.appLog("UNZIP_PROCESS", "Starting the unzipping process.");
        // buffer for read and write data to file

        List<Map<String, Object>> tree = new ArrayList<>();

        fis = new FileInputStream(zipFilePath);
        ZipInputStream zis = new ZipInputStream(fis);
        ZipEntry ze = zis.getNextEntry();
        while (ze != null) {
            String fileName = ze.getName();
            dp.appLog("ZIPPED_ENTRY_PROCESS", "Processing zipped entry");
            if (unZippedFolderPath == null)
                unZippedFolderPath = fileName;
            else {
                dp.log("Zipped entry " + fileName);
                dp.appLog("ZIPPED_ENTRY", fileName);
                fileName = ("#$" + fileName).replace("#$" + unZippedFolderPath, "");
                dp.appLog("PROCESSED_FILE_NAME", fileName);
                File newFile = new File(destDir + File.separator + fileName);
                new File(newFile.getParent()).mkdirs();

                if (fileName.endsWith(".flow") || fileName.endsWith(".api") || fileName.endsWith(".service") || fileName.endsWith(".map")
                        || fileName.endsWith(".doc") || fileName.endsWith(".package") || fileName.endsWith(".root")
                        || fileName.endsWith(".properties") || fileName.endsWith(".jar") || fileName.endsWith(".jdbc")
                        || fileName.endsWith(".sql") || fileName.endsWith(".pem")) {
                    // Add file info to map
                    Map<String, Object> fileMap = new HashMap<>();
                    fileMap.put("text", fileName);
                    fileMap.put("type", fileName.substring(fileName.lastIndexOf(".") + 1));
                    addItemToMap(destDir, fileName, fileMap, tree);
                }

                byte[] buffer = new byte[1024];
                int len = zis.read(buffer);
                if (len > 0) {
                    FileOutputStream fos = new FileOutputStream(newFile);
                    while (len > 0) {
                        fos.write(buffer, 0, len);
                        // buffer = new byte[1024]
                        len = zis.read(buffer);
                    }
                    fos.flush();
                    fos.close();
                }
            }
            // close this ZipEntry
            zis.closeEntry();
            ze = zis.getNextEntry();
        }
        // close last ZipEntry
        zis.closeEntry();
        zis.close();
        fis.close();

        dp.put("list", tree);

    }

    private static void createRestorePoint(String buildName, DataPipeline dataPipeline) throws Exception{
        String packagePath=PropertyManager.getPackagePath(dataPipeline.rp.getTenant());
        dataPipeline.appLog("EXTRACTED_PACKAGE_PATH",packagePath);
        String bkpDirPath=packagePath+"builds/backup/";
        dataPipeline.appLog("BACKUP_DIRECTORY_PATH",bkpDirPath);
        File dir=new File(bkpDirPath);
        String timeStmp=System.currentTimeMillis()+"";
        dataPipeline.appLog("TIME_STAMP",timeStmp);
        if(!dir.exists())
            dir.mkdirs();
        dataPipeline.appLog("BACKUP_DIRECTORY_CREATED",bkpDirPath);
        FileOutputStream fos = new FileOutputStream(bkpDirPath+timeStmp+"_packages_"+buildName);
        ZipOutputStream zipOut = new ZipOutputStream(fos);
        File fileToZip = new File(packagePath+"packages/");
        ServiceUtils.zipFile(fileToZip, fileToZip.getName(), zipOut);
        zipOut.flush();
        zipOut.close();
        fos.flush();
        fos.close();
        //dataPipeline.log(fileToZip.getAbsolutePath());
        //FileUtils.deleteDirectory(fileToZip);
    }

    private static void addItemToMap(String destDir, String fileName, Map<String, Object> fileMap, List<Map<String, Object>> tree) {
        String[] folders = fileName.split("/");
        List<Map<String, Object>> currentChildren = tree;

        for (int i = 0; i < folders.length - 1; i++) {
            String folderName = folders[i];
            Map<String, Object> folderMap = null;

            if (i != 0) {
                for (Map<String, Object> child : currentChildren) {
                    if (child.get("text").equals(folderName)) {
                        folderMap = child;
                        break;
                    }
                }

                if (folderMap == null) {
                    folderMap = new HashMap<>();
                    folderMap.put("text", folderName.substring(folderName.lastIndexOf("/") + 1));
                    folderMap.put("type", "folder");
                    folderMap.put("children", new ArrayList<>());
                    currentChildren.add(folderMap);
                }
            }

            currentChildren = (List<Map<String, Object>>) (folderMap != null ? folderMap.get("children") : tree);
        }

        String itemName = fileName.substring(fileName.lastIndexOf("/") + 1);
        if (!itemName.startsWith("URLAlias")) {
            itemName = itemName.contains(".") ? itemName.substring(0, itemName.lastIndexOf(".")) : itemName;
            fileMap.put("text", itemName);
            currentChildren.add(fileMap);
        }
    }





}