package packages.middleware.pub.service;
import com.eka.middleware.service.DataPipeline;
import com.eka.middleware.service.ServiceUtils;
import com.eka.middleware.template.SnippetException;
import com.eka.middleware.server.ServiceManager;

import java.util.stream.Stream;
import java.util.stream.Collectors;
import java.util.List;
import java.util.Map;
import java.io.InputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import java.io.FileInputStream;
import java.util.ArrayList;
import java.util.HashMap;
import com.eka.middleware.service.PropertyManager;
public final class findReferences{
	public static final void main(DataPipeline dataPipeline) throws SnippetException{
try {
  		dataPipeline.appLog("OPERATION", "findReference");
		String serviceFqn=dataPipeline.getString("serviceFqn");
  		dataPipeline.appLog("SERVICE_FQN", serviceFqn);
  		String packageDirectory=PropertyManager.getPackagePath(dataPipeline.rp.getTenant())+"packages/";
  		dataPipeline.appLog("EXTRACTED_PACKAGE_DIRECTORY", packageDirectory);
  		File dir=new File(packageDirectory);
  		//List<String> list=parseDirectory(dir,serviceFqn,"|");
  		List<Map<String, Object>> tree = parseDirectory(dataPipeline, dir, serviceFqn);
        dataPipeline.clear();
  		dataPipeline.put("list",tree);
  		dataPipeline.appLog("LIST_SIZE", String.valueOf(tree.size()));
  		dataPipeline.appLog("LIST", tree.toString());
        //dataPipeline.log("***********************************************\n"+list);
        
  } catch (Exception e) {
		dataPipeline.clear();
  		dataPipeline.put("error",e.getMessage());
  		dataPipeline.appLog("SERVICE_ERROR", e.getMessage());
    	throw new SnippetException(dataPipeline,"Snippet exception", new Exception(e));
  }
	}
/*private static int searchStream(File pathFile, String word) throws Exception{

    InputStream inputStream = new FileInputStream(pathFile);
    BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));
    Stream<String> linesStream = bufferedReader.lines();
    List<String> list=linesStream.filter(a -> a.contains(word)).collect(Collectors.toList());
    return list.size();

}

private static List<String> parseDirectory(File dir,String keyWord,String padding) throws Exception {
   List<String> references=new ArrayList<String>();
   List<String> paths=new ArrayList<String>();
   //paths.add(padding+"packages");
   if(dir.exists()) {
		File[] list=dir.listFiles();
		for (File file : list) {
			if(file.isDirectory()) {
              paths.add((padding+"packages"+(file.getAbsolutePath().split("packages")[1])).replace("\\","/"));
              List<String> ref=parseDirectory(file,keyWord,padding+"-");
              if(ref.size()>0){
                references.addAll(paths);
			  	references.addAll(ref);
              }
              paths.clear();
			}else if(!file.getName().endsWith(".class")){
              //System.out.println(file.getAbsolutePath());
              int count=searchStream(file,keyWord);
              if(count>0){
                references.add((padding+"packages"+(file.getAbsolutePath().split("packages")[1])).replace("\\","/")+" : "+count+" times");
              }
            }
		}
	}
  return references;
}*/

private static int searchStream(DataPipeline dataPipeline, File pathFile, String word) throws Exception {
        InputStream inputStream = new FileInputStream(pathFile);
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));
        Stream<String> linesStream = bufferedReader.lines();
        List<String> list = linesStream.filter(a -> a.contains(word)).collect(Collectors.toList());
  		dataPipeline.appLog("OCCURRENCES_COUNT", String.valueOf(list.size()));
  		inputStream.close();
  		bufferedReader.close();
        return list.size();
    }

    private static List<Map<String, Object>> parseDirectory(DataPipeline dataPipeline, File dir, String keyWord) throws Exception {
        List<Map<String, Object>> references = new ArrayList<>();
        String allowedTypes = "service,map,doc,flow,package,root,folder,properties,jar,jdbc,sql,pem";
      	dataPipeline.appLog("ALLOWED_TYPES", allowedTypes);
        if (dir.exists()) {
            File[] list = dir.listFiles();
          	dataPipeline.appLog("DIRECTORY_EXISTS", "true");
            for (File file : list) {
                if (file.isDirectory()) {
                    Map<String, Object> node = new HashMap<>();
                    node.put("text", file.getName());
                    node.put("type", "folder");
                    node.put("children", parseDirectory(dataPipeline, file, keyWord));
                    if (!node.get("children").equals(new ArrayList<>())) {
                        references.add(node);
                      	dataPipeline.appLog("NODE_ADDED", "Added node with children");
                    }
                }else if(file.getName().endsWith(".flow") || file.getName().endsWith(".properties")){
                    int count = searchStream(dataPipeline, file, keyWord);
                  	dataPipeline.appLog("FILE_INFO", "Searching file: " + file.getName());
                    if (count > 0) {
                        Map<String, Object> node = new HashMap<>();
                        node.put("text", file.getName() + " : " + count + " times");
                        int indx = file.getName().lastIndexOf(".") + 1;
                        String fileType = file.getName().substring(indx);
                      	dataPipeline.appLog("FILE_TYPE", fileType);
                        if (allowedTypes.contains(fileType)) {
                            node.put("type", fileType);
                            references.add(node);
                          	dataPipeline.appLog("NODE_ADDED", "Node added");
                        }
                    }
                }
            }
        }
        return references;
    }
}